codeforces 687C (纸币dp)(状态不好想)

xiaoxiao2021-02-28  103

Pari wants to buy an expensive chocolate from Arya. She has n coins, the value of the i-th coin is ci. The price of the chocolate is k, so Pari will take a subset of her coins with sum equal to k and give it to Arya.

Looking at her coins, a question came to her mind: after giving the coins to Arya, what values does Arya can make with them? She is jealous and she doesn’t want Arya to make a lot of values. So she wants to know all the values x, such that Arya will be able to make x using some subset of coins with the sum k.

Formally, Pari wants to know the values x such that there exists a subset of coins with the sum k such that some subset of this subset has the sum x, i.e. there is exists some way to pay for the chocolate, such that Arya will be able to make the sum x using these coins.

Input The first line contains two integers n and k (1  ≤  n, k  ≤  500) — the number of coins and the price of the chocolate, respectively.

Next line will contain n integers c1, c2, …, cn (1 ≤ ci ≤ 500) — the values of Pari’s coins.

It’s guaranteed that one can make value k using these coins.

Output First line of the output must contain a single integer q— the number of suitable values x. Then print q integers in ascending order — the values that Arya can make for some subset of coins of Pari that pays for the chocolate.

Example Input 6 18 5 6 1 10 12 2 Output 16 0 1 2 3 5 6 7 8 10 11 12 13 15 16 17 18 Input 3 50 25 25 50 Output 3 0 25 50

题意:给你 n种纸币 让你凑出 k元。问拿来凑的这些钱能拿来凑出什么样的面值。

dp[i][j] i为总钱数,j是钱数,存的是 有i钱能否凑出j钱。 dp[i][j] 只有两种转移方式 dp[i-m][j] 或者 dp[i-m][j-m] 然后转移即可,要注意边界 要注意两个点: 1.因为是每个只能取一次 所以要01背包的逆序 2.不是所有的 dp[i][0] 都等于1 因为 i不一定存在,就是不一定能凑出i的钱数

#include <bits/stdc++.h> using namespace std; #define fi first #define se second #define ff(i,a,b) for(int i = a; i <= b; i++) #define f(i,a,b) for(int i = a; i < b; i++) typedef pair<int,int> P; #define ll long long int c[510]; int dp[510][510]; int main() { ios::sync_with_stdio(false); int n,k; cin >> n >> k; ff(i,1,n) cin >> c[i]; dp[0][0] = 1; ff(w,1,n) for(int i = k; i >= 1; i--) for(int j = k; j >= 0; j--) { if(i >= c[w]) dp[i][j]|= dp[i - c[w]][j]; if(i >= c[w] && j >= c[w]) dp[i][j]|= dp[i - c[w]][j - c[w]]; } vector<int> ans; // ff(i,1,k) // { // ff(j,0,k) // printf("%d ",dp[i][j] ); // puts(""); // } ff(i,0,k) if(dp[k][i]) ans.push_back(i); printf("%d\n",(int)ans.size()); f(i,0,ans.size()) printf("%d ",ans[i] ); return 0; }
转载请注明原文地址: https://www.6miu.com/read-42453.html

最新回复(0)